/*
   +----------------------------------------------------------------------+
   | Turck MMCache for PHP Version 4                                      |
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2003 TurckSoft, St. Petersburg                    |
   | http://www.turcksoft.com                                             |
   +----------------------------------------------------------------------+
   | This program is free software; you can redistribute it and/or        |
   | modify it under the terms of the GNU General Public License          |
   | as published by the Free Software Foundation; either version 2       |
   | of the License, or (at your option) any later version.               |
   |                                                                      |
   | This program is distributed in the hope that it will be useful,      |
   | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
   | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
   | GNU General Public License for more details.                         |
   |                                                                      |
   | You should have received a copy of the GNU General Public License    |
   | along with this program; if not, write to the Free Software          |
   | Foundation, Inc., 59 Temple Place - Suite 330, Boston,               |
   | MA  02111-1307, USA.                                                 |
   |                                                                      |
   | A copy is availble at http://www.gnu.org/copyleft/gpl.txt            |
   +----------------------------------------------------------------------+
   | Author: Dmitry Stogov <mmcache@turcksoft.ru>                         |
   +----------------------------------------------------------------------+
   $Id: opcodes.h,v 1.9 2003/07/11 13:40:03 dstogov Exp $
*/

#include "mmcache.h"

#ifdef HAVE_MMCACHE
#if defined(WITH_MMCACHE_DISASSEMBLER) || defined(WITH_MMCACHE_ENCODER) || defined(WITH_MMCACHE_LOADER)

#define EXT_MASK       0x0f00
#define EXT_UNUSED     0x0f00
#define EXT_STD        0x0000
#define EXT_OPLINE     0x0100
#define EXT_FCALL      0x0200
#define EXT_ARG        0x0300
#define EXT_SEND       0x0400
#define EXT_CAST       0x0500
#define EXT_INIT_FCALL 0x0600
#define EXT_FETCH      0x0700
#define EXT_DECLARE    0x0800
#define EXT_SEND_NOREF 0x0900
#define EXT_FCLASS     0x0a00
#define EXT_IFACE      0x0b00
#define EXT_ISSET      0x0c00
#define EXT_BIT        0x0d00
#define EXT_CLASS      0x0e00

#define OP1_MASK       0x00f0
#define OP1_UNUSED     0x00f0
#define OP1_STD        0x0000
#define OP1_OPLINE     0x0010
#define OP1_ARG        0x0020
#define OP1_BRK        0x0030
#define OP1_CONT       0x0040
#define OP1_JMPADDR    0x0050
#define OP1_CLASS      0x0060
#define OP1_VAR        0x0070
#define OP1_TMP        0x0080
#define OP1_UCLASS     0x0090

#define OP2_MASK       0x000f
#define OP2_UNUSED     0x000f
#define OP2_STD        0x0000
#define OP2_OPLINE     0x0001
#define OP2_FETCH      0x0002
#define OP2_INCLUDE    0x0003
#define OP2_ARG        0x0004
#define OP2_ISSET      0x0005
#define OP2_JMPADDR    0x0006
#define OP2_CLASS      0x0007
#define OP2_VAR        0x0008
#define OP2_TMP        0x0009

#define RES_MASK       0xf000
#define RES_UNUSED     0xf000
#define RES_STD        0x0000
#define RES_CLASS      0x1000
#define RES_TMP        0x2000
#define RES_VAR        0x3000

#define OPS_STD       EXT_STD | OP1_STD | OP2_STD | RES_STD

#ifdef ZEND_ENGINE_2
#  define VAR_NUM(var) (((temp_variable *)(var))-((temp_variable *)NULL))
#  define VAR_VAL(var) ((var)*sizeof(temp_variable))
#else
#  define VAR_NUM(var) (var)
#  define VAR_VAL(var) (var)
#endif

typedef struct {
#ifdef WITH_MMCACHE_DISASSEMBLER
  const char*  opname;
#endif
  unsigned int ops;
} opcode_dsc;

const opcode_dsc* get_opcode_dsc(unsigned int n);

#endif

#ifdef ZEND_ENGINE_2
#  define LAST_OPCODE 146

opcode_handler_t get_opcode_handler(zend_uchar opcode TSRMLS_DC);

#else
#  define LAST_OPCODE 106
#endif

#endif
